//#include <DHT22.h>





#include <ESP8266WiFi.h>
#include <PubSubClient.h>
#include <DHT.h>

#define DHTPIN 2
#define DHTTYPE DHT22

DHT dht(DHTPIN, DHTTYPE);

const char *ssid =  "Huawei_pwd";  // Имя вайфай точки доступа
const char *pass =  "pp1ww2dd3"; // Пароль от точки доступа

const char *mqtt_server = "192.168.1.211"; // Имя сервера MQTT
const int mqtt_port = 1883; // Порт для подключения к серверу MQTT
const char *mqtt_user = ""; // Логи от сервер
const char *mqtt_pass = ""; // Пароль от сервера

#define BUFFER_SIZE 100

bool LedState = false;
int tm=300;
int tmvrem=300; // по умолчанию
int tm1=300;
int autom=1; //если 0 - то ручное, если 1 - то автоматическое
int hum_min = 45; //минимальная влажность
int hum_max = 65; //максимальная влажность
float temp=0;
float h,t;
int input_1,input_2,input_3,input_4,input_all,out_1,out_2,out_3,out_4,out_all;


// Функция получения данных от сервера
void callback(const MQTT::Publish& pub){
  Serial.print(pub.topic());   // выводим в сериал порт название топика
  Serial.print(" => ");
  Serial.println(pub.payload_string()); // Данные из топика

  if  (pub.topic() == "Relay_1")  {
    if  (pub.payload_string() == "ON")  {
      digitalWrite(16, HIGH);
    }
    if  (pub.payload_string() == "OFF")  {
      digitalWrite(16, LOW);
    }
  }

  if  (pub.topic() == "Relay_2")  {
    if  (pub.payload_string() == "ON")  {
      digitalWrite(5, HIGH);
    }
    if  (pub.payload_string() == "OFF")  {
      digitalWrite(5, LOW);
    }
  }

  if  (pub.topic() == "Relay_3")  {
    if  (pub.payload_string() == "ON")  {
      digitalWrite(4, HIGH);
    }
    if  (pub.payload_string() == "OFF")  {
      digitalWrite(4, LOW);
    }
  }


  if  (pub.topic() == "Relay_4")  {
    if  (pub.payload_string() == "ON")  {
      digitalWrite(0, HIGH);
    }
    if  (pub.payload_string() == "OFF")  {
      digitalWrite(0, LOW);
    }
  }
}

WiFiClient wclient;      
PubSubClient client(wclient, mqtt_server, mqtt_port);

void setup() {
  Serial.begin(115200);
  delay(10);
  Serial.println();
  pinMode(16, OUTPUT); // отмечаем, что порт будет ВЫХОДОМ 
  pinMode(5, OUTPUT); // отмечаем, что порт будет ВЫХОДОМ
  pinMode(4, OUTPUT); // отмечаем, что порт будет ВЫХОДОМ 
  pinMode(0, OUTPUT); // отмечаем, что порт будет ВЫХОДОМ  
 
  pinMode(14, INPUT_PULLUP); // отмечаем, что порт будет ВХОДОМ
  pinMode(12, INPUT_PULLUP); // отмечаем, что порт будет ВХОДОМ
  pinMode(13, INPUT_PULLUP); // отмечаем, что порт будет ВХОДОМ
  pinMode(3, INPUT_PULLUP); // отмечаем, что порт будет ВХОДОМ

     
  dht.begin();        // запускаем библиотеку датчика DHT22
}





void loop() {
  TempHum(); // чтение показаний с датчика DHT22
   delay(10);

  // подключаемся к wi-fi
  if (WiFi.status() != WL_CONNECTED) {
    Serial.print("Connecting to ");
    Serial.print(ssid);
    Serial.println("...");
    WiFi.begin(ssid, pass);

    if (WiFi.waitForConnectResult() != WL_CONNECTED)
      return;
    Serial.println("WiFi connected");
  }

  // подключаемся к MQTT серверу
  if (WiFi.status() == WL_CONNECTED) {
    if (!client.connected()) {
      Serial.println("Connecting to MQTT server");
      if (client.connect(MQTT::Connect("arduinoClient2")
                         .set_auth(mqtt_user, mqtt_pass))) {
        Serial.println("MQTT server connected");
        client.set_callback(callback);
        client.subscribe("Relay_1"); // подписывааемся по топик с данными для управления реле
        client.subscribe("Relay_2"); 		
        client.subscribe("Relay_3"); 		
        client.subscribe("Relay_4");   	
        //client.subscribe("test/aut1"); // подписывааемся на другие топики
        //client.subscribe("test/hmin1");
      } else {
        Serial.println("Could not connect to MQTT server");   
      }
    }

    if (client.connected()){ // если есть соединение
      client.loop();
      TempSend(); // Функция отправки показаний с термодатчика
      Inputs(); // Функция чтения и отправки состояния входов
      Outs(); // Функция чтения и отправки состояния входов
     }
  
  }
} // конец основного цикла




void Inputs(){
   
   int pinState_1 = digitalRead(14);       
if (pinState_1 == LOW) {
   input_1 = 11;
   }
else{
  input_1 = 0;
}
   


   int pinState_2 = digitalRead(12);
if (pinState_2 == LOW) {
   input_2 = 12;
   }
else{
  input_2 = 0;
}


   int pinState_3 = digitalRead(13); 
if (pinState_3 == LOW) {
   input_3 = 14;
   }

else{
  input_3 = 0;
}
   int pinState_4 = digitalRead(3);  

   
if (pinState_4 == LOW) {
   input_4 = 18;
   }

else{
  input_4 = 0;
}


input_all = input_1 + input_2 + input_3 + input_4;

input_all = int(input_all);


    client.publish("Inputs", String(input_all));

}





void Outs(){
   
   int pinOut_1 = digitalRead(16);       
if (pinOut_1 == LOW) {
   out_1 = 0;
   }
else{
  out_1 = 11;
}
   


   int pinOut_2 = digitalRead(5);
if (pinOut_2 == LOW) {
   out_2 = 0;
   }
else{
  out_2 = 12;
}


   int pinOut_3 = digitalRead(4); 
if (pinOut_3 == LOW) {
   out_3 = 0;
   }

else{
  out_3 = 14;
}
   int pinOut_4 = digitalRead(0);  

   
if (pinOut_4 == LOW) {
   out_4 = 0;
   }

else{
  out_4 = 18;
}


out_all = out_1 + out_2 + out_3 + out_4;

out_all = int(out_all);


    client.publish("Outs", String(out_all));

}
















// Функция отправки показаний с термодатчика
void TempSend(){
  if (tm==0)
  {
   h = dht.readHumidity();
   t = dht.readTemperature();
   //h=67;
   //t=32;
   // Read temperature as Celsius (the default)


  client.publish("DHT22", String(t)+String(h));
  Serial.println(t);
  Serial.println(h);


  //client.publish("DHT22_t",String(t)); // отправляем в топик для термодатчика значение температуры
  //Serial.println((t));
  //client.publish("DHT22_rh",String(h)); // отправляем в топик для термодатчика значение влажности
  //Serial.println(h);

  tm = tmvrem;  // пауза меду отправками значений 
  }
  tm--; 
  delay(50);  
}


// чтение данных с датчика DHT22, 1 раз в 3с.
void TempHum(){
   if (tm1==0)
  {
     h = dht.readHumidity();
     t = dht.readTemperature();
     tm1 = 300;
  }
   tm1--; 
  delay(10);
}


